//+------------------------------------------------------------------+
//|                                          Trend Catcher v0.50.mq4 |
//|                                       Copyright  2008 Tom Balfe |
//|                   http://www.forex-tsd.com/members/nittany1.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Tom Balfe"
#property link      "http://www.forex-tsd.com/members/nittany1.html"

//+------------------------------------------------------------------+
//| USER ADJUSTABLE STUFF                                            |
//+------------------------------------------------------------------+

extern  string  TopOfSetting          = "=== Trend Catcher v0.50 EA ===";
extern bool     Aktifkan_EA_Hi_Lo     = True;

extern  int     MagicNumber           = 965843;

extern int      HiLo_period           = 15; // Hi-Lo condition for OPEN position
//extern int      HiLo_Close_period     = 20; // Hi-Lo condition for CLOSE position
extern int      ADXperiod             = 3;
extern int      ADXtrend              = 25;
extern  string  Order_Settings        = "=== Order Settings ===";
extern  double  StaticLots            = 0.1;
extern  int     Slippage              = 2;
extern  int     TP                    = 300; // buat maximu 300, krn bakal sering kena TS Asisten
extern  int     SL                    = 22; // idal 20
//extern string  __________oMn__________ = "Sama dengan trailing biasa di MT4";
extern bool    Aktifkan_Trailing       = true;
extern int     TrailingStop            = 22;       // Trailing ini sama dengan Trailing Normal di MT4
 string  ___________oMn_________ = "Profit >= JagaSaatUntung";
extern int     JagaSaatUntung          = 20;
extern int     PenjagaUntung           = 5;       // Aktif jika Profit Point lebih besar dari PenjagaGawang*4
                             

extern  string  MM_Settings           = "=== Money Management ===";
extern  bool    UseMM                 = false;
extern  int     PercentAtRisk         = 3;

//+------------------------------------------------------------------+
//| DON'T CHANGE BELOW HERE                                          |
//+------------------------------------------------------------------+
//| Program initializes and deinitializes here.                      |
//+------------------------------------------------------------------+
string        EAComment   = "Trend Catcher v0.51 EA";
string        EATitle     = "TREND CATCHER v0.51 EA  2008 TOM BALFE";
int           OpenOrders  = 1; // harus angka 1 jangan angka yg lainnya !!!
datetime      PreviousBar;

int init()
  {
  ObjectCreate("Title",OBJ_LABEL,0,0,0);
  ObjectSet("Title",OBJPROP_XDISTANCE,325);
  ObjectSet("Title",OBJPROP_YDISTANCE,2);
  ObjectSetText("Title",EATitle,9,"Lucida Sans Regular",PaleTurquoise);

  return(0);
  }

int deinit()
  {
    if (TotalOpenOrders() > 0)
    {
    CloseAll();
    } 
  
  ObjectsDeleteAll();
  ObjectDelete("Title");
    
  return(0);
  }

int start()
  {
  if (Aktifkan_EA_Hi_Lo)
  {
  //--- Hi-Low 
 
  double HLbuy   = iCustom(NULL,0,"Hi-Lo",HiLo_period,300,1,0); // buy
  double HLsell  = iCustom(NULL,0,"Hi-Lo",HiLo_period,300,0,0); // sell
  
  //double HLbuy_15   = iCustom(NULL,0,"Hi-Lo",8,300,1,0); // buy
  //double HLsell_15  = iCustom(NULL,0,"Hi-Lo",8,300,0,0); // sell
  
  //double HLbuy_30   = iCustom(NULL,0,"Hi-Lo",12,300,1,0); // buy
  //double HLsell_30  = iCustom(NULL,0,"Hi-Lo",12,300,0,0); // sell
  
  //double HLbuy_60   = iCustom(NULL,60,"Hi-Lo",HiLo_period,300,1,0); // buy
  //double HLsell_60  = iCustom(NULL,60,"Hi-Lo",HiLo_period,300,0,0); // sell
  
  //double HL_Close_Buy   = iCustom(NULL,0,"Hi-Lo",HiLo_Close_period,300,1,0); // buy
  //double HL_Close_Sell  = iCustom(NULL,0,"Hi-Lo",HiLo_Close_period,300,0,0); // sell
  double ADXmain_0 = iADX(Symbol(), 0, ADXperiod, 0, MODE_MAIN, 0);
  double ADXmain_1 = iADX(Symbol(), 0, ADXperiod, 0, MODE_MAIN, -1);
  double ADXplus = iADX(Symbol(), 0, ADXperiod, 0, MODE_PLUSDI, 0);
  double ADXmins = iADX(Symbol(), 0, ADXperiod, 0, MODE_MINUSDI, 0);
  //--- Order Entry ---//
  
  if (NewBar() == true) {
  //---------------- check indicators and look for a CLOSE ---//
    if (TotalOpenOrders() == OpenOrders)
    {
      if (OrderType() == OP_BUY) 
        {
        if (HLsell > 0) { CloseAll(); }
        //if ( (HLsell > 0) && (ADXmins>ADXplus) && (ADXmins>ADXtrend) ) { CloseAll(); }
        }
    
      if (OrderType() == OP_SELL) 
        {
        if (HLbuy > 0) { CloseAll(); }
        //if ( (HLbuy > 0) && (ADXplus>ADXmins) && (ADXplus>ADXtrend) ) { CloseAll(); }
        }
    }
  
    //---------------- check indicators and look for a ORDER ENTRY ---//
    if (TotalOpenOrders() < OpenOrders)
    {
      //-- BUY
      if ( (HLbuy > 0) && (ADXplus>ADXmins) && (ADXplus>ADXtrend) && (ADXmain_0>ADXtrend) && (ADXmain_0>ADXmain_1) )
      //if (HLbuy > 0) 
      //if ( (HLbuy > 0) && (HLbuy_15 > 0) && (HLbuy_30 > 0) )
      {
        OrderSend(Symbol(),OP_BUY,LotSize(),Ask,Slippage,Ask-SL*Point,Ask+TP*Point,EAComment,MagicNumber,0,Lime);  
      }
    
      //-- SELL
      if ( (HLsell > 0) && (ADXmins>ADXplus) && (ADXmins>ADXtrend) && (ADXmain_0>ADXtrend) && (ADXmain_0>ADXmain_1) ) 
      //if (HLsell > 0)
      //if ( (HLsell > 0) && (HLsell_15 > 0) && (HLsell_30 > 0) )
      {
        OrderSend(Symbol(),OP_SELL,LotSize(),Bid,Slippage,Bid+SL*Point,Ask-TP*Point,EAComment,MagicNumber,0,Red);
      }
    }
  }
  
 //+---------------------------------------------------- ******** || ********* ------------------------------------------------+
      if(Aktifkan_Trailing==true)
      {
      //TRAILING STOP BUY
       if ((OrderType()==OP_BUY) && (OrderSymbol() == Symbol() ))
         {
          if(TrailingStop>0)
            {	
             if (((MarketInfo(OrderSymbol(),MODE_BID))-OrderOpenPrice())>(TrailingStop*Point))
               {
                if ((OrderStopLoss()<((MarketInfo(OrderSymbol(),MODE_BID))-(TrailingStop*Point))) || OrderStopLoss()==0)
                  {
                   OrderModify(OrderTicket(),OrderOpenPrice(),((MarketInfo(OrderSymbol(),MODE_BID))-(TrailingStop*Point)),OrderTakeProfit(),Lime);
                   return(0);
                  } 
               }
            }
         }
         
      //TRAILING STOP SELL
        if ((OrderType() == OP_SELL) && (OrderSymbol() == Symbol() ))
          {
	  	     if (TrailingStop>0)
             {
              if ((OrderOpenPrice()-(MarketInfo(OrderSymbol(),MODE_ASK)))>(TrailingStop*Point))
                {
                 if ((OrderStopLoss()>((MarketInfo(OrderSymbol(),MODE_ASK))+(TrailingStop*Point))) || OrderStopLoss()==0)
                   {
                    OrderModify(OrderTicket(),OrderOpenPrice(),((MarketInfo(OrderSymbol(),MODE_ASK))+(TrailingStop*Point)),OrderTakeProfit(),Red);
                    return(0);
                   }
                }
             }
           }
      } //if aktifkan trailing stop
       
	 
	  	 if ((OrderType()==OP_BUY) && (OrderSymbol() == Symbol() ))
	  	   {  
	  	    //Penjaga Profit Buy
	  	    if ((PenjagaUntung>0) && (JagaSaatUntung>0))
	  	      {	
             if (((MarketInfo(OrderSymbol(),MODE_BID))-OrderOpenPrice())>(JagaSaatUntung*Point))
	            {
                if ((OrderStopLoss()<(OrderOpenPrice())) || OrderStopLoss()==0)   //kalimat ini yang membbuatnya tidak kembali-kembali
                  {
                   OrderModify(OrderTicket(),OrderOpenPrice(),((OrderOpenPrice())+(PenjagaUntung*Point)),OrderTakeProfit(),Lime);
                   return(0);
   	            }
   	         }
   	      }
         }
         
       if ((OrderType() == OP_SELL) && (OrderSymbol() == Symbol() ))
         {
          //Penjaga Profit SELL
	  	    if ((PenjagaUntung>0) && (JagaSaatUntung>0))
            {
             if ((OrderOpenPrice()-(MarketInfo(OrderSymbol(),MODE_ASK)))>(JagaSaatUntung*Point))
	            {
                if (((OrderStopLoss())>(OrderOpenPrice())) || (OrderStopLoss()==0))
                  {
                   OrderModify(OrderTicket(),OrderOpenPrice(),((OrderOpenPrice())-(PenjagaUntung*Point)),OrderTakeProfit(),Red);
                   return(0);
                  }
	  	         }
	  	      }
	  	   }
//+---------------------------------------------------- ******** || ********* ------------------------------------------------+

   } 	  // aktifkan ea hi_lo  
	  	     
	  	     
  
  ShowInfo();
  
  return(0);
  } //start

//+------------------------------------------------------------------+
//| COMMON FUNCTIONS                                                 |
//+------------------------------------------------------------------+
//| The expert will call these from the main loop.                   |
//+------------------------------------------------------------------+

//+-----------------------------------------------------+
//|           new bar                                   |
//+-----------------------------------------------------+
bool NewBar()
{
  if(PreviousBar<Time[0])
  {
    PreviousBar = Time[0];
    return(true);
  }
  else
  {
    return(false);
  }
  return(false);  
}

//+-----------------------------------------------------+
//|           calculate lot size                        |
//+-----------------------------------------------------+
double LotSize()
{
  if (UseMM == true) 
    { double Lots = MathCeil(AccountFreeMargin() *  PercentAtRisk / 1000) / 100; }
  
  else { Lots = StaticLots; }
  
  return(Lots);  
}

//+-----------------------------------------------------+
//|           close all                                 |
//+-----------------------------------------------------+
//| Finds any open orders & closes them                 |
//+-----------------------------------------------------+
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type = OrderType();
    
    if (OrderSymbol()==Symbol() && (OrderMagicNumber() == MagicNumber))  
    {
      //-- Close open BUYs
      if (type == OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,CornflowerBlue);
      //-- Close open SELLS
      if (type == OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,CornflowerBlue);
    }
  }
  return;
}

//+-----------------------------------------------------+
//|           calculate open orders                     |
//+-----------------------------------------------------+
int TotalOpenOrders()
{
  int j = 0;
  j=OrdersTotal();
  int TotalOpenOrders = 0;
   
  if(j==0) { return (0); }
  
  else
  {
    for(;j>=0;j--)
      {
      RefreshRates();
      OrderSelect(j,SELECT_BY_POS);
      if(OrderMagicNumber()==MagicNumber)
      {
        TotalOpenOrders++;
      }
    }
  }
  return(TotalOpenOrders);
}

//+-----------------------------------------------------+
//|           show summary panel on chart               |
//+-----------------------------------------------------+
void ShowInfo()
{
  Comment("...::: Trend Catcher v0.51 :::...\n",
          "Copyright  2008 Tom Balfe\n",
          "Currency Pair: ", Symbol(),"\n",
          "Price:  ",NormalizeDouble(Bid,4),"\n",
          "Date: ",Month(),"-",Day(),"-",Year()," Server Time: ",Hour(),":",Minute(),":",Seconds(),"\n",
          "Minimum Lot Size: ",MarketInfo(Symbol(),MODE_MINLOT),"\n",
          "Lot for open trade = ", StaticLots, "\n",
          "Take Profit  = ", TP, "\n",
          "Stop Loss    = ", SL, "\n",
          "Hi-Lo period = ", HiLo_period, "\n",
          "ADX period   = ", ADXperiod, "\n",
          "ADX trend    = ", ADXtrend, "\n",
          "Slippage     = ", Slippage, "\n",
          "Magic Number = ", MagicNumber, "\n",
          "Last Error : ", GetLastError(), " , " 
          );
  return(0);
}